package xyz.thastertyn.Scrape;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.HashSet;

import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.Types.Options;
import xyz.thastertyn.Types.Timetable;

/**
 * Jeden radek v rozvrhu
 */
public class Rozvrh extends JecnaScrape {
	
	private Timetable timetable;
	/**
	 * Stahne rozvrh z www.spsejecna.cz a dale ho zpracuje do formy
	 * se kterou da pracovat
	 * @param Jsessionid ze stranek
	 * @throws UnknownHostException kdyz neni pripojeni k internetu
	 * @throws IOException ostatni exceptiony nejsou dulezite, tak jsou zahrnuty v jednom
	 */
	@Override
	public void download() throws IOException
	{
		timetable = new Timetable();
		Document rozvrhDokumentHTML = Downloader.download("https://www.spsejecna.cz/timetable/class").get();

		Elements[] radkyRozvrhuHTML = rozvrhDokumentHTML
			.select("table.timetable")
			.select("tr")
			.stream()
			.map(Element::children)
			.toArray(Elements[]::new);

		for(int i = 0; i < 5; i++)
		{
			for(int j = 0; j < 10; j++)
			{
				String predmet = radkyRozvrhuHTML[i+1].get(j+1).select("span.subject").text();

				// Predmety jako CEL jsou trikrat, staci ale jen jednou
				String[] split = predmet.split(" ");
				HashSet<String> set = new HashSet<>(Arrays.asList(split));
				String pr = String.join("/", set);

				timetable.get(i).set(j, pr);
			}
		}
	}

	public Timetable getRozvrh()
	{
		return timetable;
	}

	@Override
	public String toString()
	{
		return (timetable == null) ?
			"Nothing downloaded yet"
			:
			"All up and ready";
	}

	@Override
	public Options[] getOptions() {
		// TODO Auto-generated method stub
		throw new UnsupportedOperationException("Unimplemented method 'getOptions'");
	}

	@Override
	public void download(Choice choice) throws IOException {
		// TODO Auto-generated method stub
		throw new UnsupportedOperationException("Unimplemented method 'download'");
	}
}
