package xyz.thastertyn.UserInterface.Content;

import java.io.IOException;

import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;

import xyz.thastertyn.Scrape.JecnaScrape;
import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.UserInterface.UpdateListener;
import xyz.thastertyn.UserInterface.Dialogs.OptionsDialog;


/**
 * Wrapper to include all classes that deal with content in some way
 */
public abstract class JecnaContent {
	
	protected Panel mainPanel;
	protected boolean hasStarted = false;
	protected Label borderLabel;
	protected UpdateListener listener;
	protected JecnaScrape scraper;

	protected abstract void setGUI();

	public JecnaContent(UpdateListener listener)
	{
		this.listener = listener;
	}
	
	protected void download(Choice choice) throws IOException
	{
		if(choice != null)
		{
			scraper.download(choice);
			setGUI();
			listener.updatePanel();
		}else{
			scraper.download();
			setGUI();
		}

		hasStarted = true;
	}

	public void downloadDefault() throws IOException
	{
		download(null);
	}

	public void showOptions(WindowBasedTextGUI textGUI) throws IOException {
		OptionsDialog dialog = new OptionsDialog(scraper.getOptions());

		Choice choice = dialog.showDialog(textGUI);

		if(choice != null)
		{
			download(choice);
		}
	}

	public Panel getPanel()
	{
		return this.mainPanel;
	}

	public boolean hasStarted()
	{
		return this.hasStarted;
	}

	public Label getLabel()
	{
		return this.borderLabel;
	}
}
