package xyz.thastertyn.UserInterface.Content;

import java.io.IOException;
import java.util.ArrayList;

import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;

import xyz.thastertyn.Tuples.Pair;
import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.UserInterface.UpdateListener;

public class OmluvnyList extends JecnaContent{
	
	private Panel omluvnyPanel = new Panel();
	private Label borderLabel = new Label("Omluvny L.");
	private xyz.thastertyn.Scrape.OmluvnyList omluvnyList = new xyz.thastertyn.Scrape.OmluvnyList();

	private boolean hasStarted = false;

	public OmluvnyList(UpdateListener listener)
	{
		super(listener);
	}

	@Override
	public void downloadDefault() throws IOException
	{
		download(null);
	}

	@Override
	protected void download(Choice choice) throws IOException
	{
		omluvnyList = new xyz.thastertyn.Scrape.OmluvnyList();
		if(choice != null)
		{
			omluvnyList.download(choice);
			setGUI();
			listener.updatePanel();
		}else{
			omluvnyList.download();
			setGUI();
		}

		super.hasStarted = true;
	}

	@Override
	protected void setGUI()
	{
		ArrayList<Pair<String, String>> a = omluvnyList.getData();

		for(Pair<String, String> p : a)
		{
			omluvnyPanel.addComponent(new Label(p.getValue0() + " - " + p.getValue1()));
		}
	}

	@Override
	public Panel getPanel() {
		return omluvnyPanel;
	}
	
	@Override
	public boolean hasStarted() {
		return hasStarted;
	}

	@Override
	public Label getLabel() {
		return borderLabel;
	}

	@Override
	public void showOptions(WindowBasedTextGUI textGUI) {
		// TODO Auto-generated method stub
		throw new UnsupportedOperationException("Unimplemented method 'getOptions'");
	}
}
