package xyz.thastertyn.UserInterface.Content;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.table.Table;

import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.Types.Timetable;
import xyz.thastertyn.UserInterface.UpdateListener;

public class Rozvrh extends JecnaContent {

	private Panel rozvrhPanel = new Panel();
	private Label borderLabel = new Label("Rozvrh");
	private xyz.thastertyn.Scrape.Rozvrh rozvrh = new xyz.thastertyn.Scrape.Rozvrh();

	private String[] labels = {"Den", "7:30-8:15", "8:25-9:10", "9:20-10:05", "10:20-11:05", "11:15-12:00", "12:10-12:55", "13:05-13:50", "14:00-14:45", "14:55-15:40", "15:50-16:35"};
	//private String[] labels = {"Den", "1.", "2.", "3.", "4.", "5.", "6.", "7.", "8.", "9.", "10."};

	String[] daysLabels = {"PO", "UT", "ST", "CT", "PA"};
	
	Table<String> table = new Table<>(labels);

	public Rozvrh(UpdateListener listener)
	{
		super(listener);
		super.mainPanel = this.mainPanel;
		super.borderLabel = this.borderLabel;
		super.scraper = this.rozvrh;
	}

	@Override
	protected void download(Choice choice) throws IOException
	{
		if(choice != null)
		{
			scraper.download(choice);
			setGUI();
			listener.updatePanel();
		}else{
			scraper.download();
			setGUI();
		}

		hasStarted = true;
	}

	@Override
	protected void setGUI()
	{
		Timetable timetable = rozvrh.getRozvrh();
	
		for(int day = 0; day < 5; day++)
		{
			List<String> currentRow = new ArrayList<>();

			// Set the day (Po, Ut, St,...)
			currentRow.add(daysLabels[day]);

			// Add the classes
			for(int hour = 0; hour < 10; hour++)
			{
				currentRow.add((timetable.get(day).get(hour).isBlank()) ?
					" - " // Empty class, nothing taught at that moment
					:
					timetable.get(day).get(hour)); // Get class
			}

			table.getTableModel().addRow(currentRow);
		}
		rozvrhPanel.addComponent(table);
	}
}
